\pset null '\\N'

SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(beque)$re$);
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(beque)$re$, false);
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(beque)$re$, true);

-- empty capture group (matched empty string)
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(.*)(beque)$re$);
-- no match
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(.+)(beque)$re$);
-- optional capture group did not match, null entry in array
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(.+)?(beque)$re$);

-- nothing before match, empty string
SELECT * FROM regexp_matches('barbequebaz', $re$(bar)(beque)$re$, true);
SELECT * FROM regexp_matches('barbequebaz', $re$^(bar)(beque)$re$, true);
SELECT * FROM regexp_matches('barbequebaz', $re$(^bar)(beque)$re$, true);

-- nothing after match, empty string
SELECT * FROM regexp_matches('foobarbeque', $re$(bar)(beque)$re$, true);
SELECT * FROM regexp_matches('foobarbeque', $re$(bar)(beque)$$re$, true);
SELECT * FROM regexp_matches('foobarbeque', $re$(bar)(beque$)$re$, true);

-- no capture groups, should first throw error?
SELECT * FROM regexp_matches('foobarbequebaz', $re$barbeque$re$);
SELECT * FROM regexp_matches('foobarbequebaz', $re$barbeque$re$, false);
SELECT * FROM regexp_matches('foobarbequebaz', $re$barbeque$re$, true);

-- vim: set ft=psql :
